# Create your views here.
from django.contrib.contenttypes.models import ContentType
from django.shortcuts import get_object_or_404
from ox.django.shortcuts import render_to_json_response


def geojson(request, ctype_id):
    ctype = get_object_or_404(ContentType, pk=ctype_id)
    model_class = ctype.model_class()
    features = [obj.get_geojson() for obj in model_class.objects.all()]
    return render_to_json_response({
        'type': 'FeatureCollection',
        'features': features
    })

