from django.contrib.gis import admin
from models import *
# from forms import BaseRelationsFormSet
#from django import forms
#from django.contrib.admin import SimpleListFilter
#from ajax_select.fields import AutoCompleteSelectMultipleField, AutoCompleteSelectField

class BaseGeoAdmin(admin.OSMGeoAdmin):
    openlayers_url = 'http://openlayers.org/dev/OpenLayers.js'
    openlayers_img_path = None    
    map_template = 'gis/admin/osm.html'
    default_lon = 72.855211097628413
    default_lat = 19.415775291486027
    default_zoom = 4


class OpenSpaceAdmin(BaseGeoAdmin):
#    fields = ('preferred_name', 'feature_type', 'admin1', 'admin2', 'geometry', 'url', 'authority_record', 'time_frame', 'is_primary',)
    search_fields = ['name', 'address']
    list_filter = ('ward', 'reservation', 'occupied',)
    list_display = ('address', 'ward', 'reservation', 'occupied', 'cts', 'area',)    
#    inlines = [FeatureNamesInline]
#    list_display = ('__unicode__', 'feature_type_name', 'admin1', 'admin2', 'time_start', 'time_end',)
#    list_per_page = 30
#    form = featuresForm
#    readonly_fields = ['geometry']
#    map_template = 'gis/admin/osm.html'
#    default_lon = 72.855211097628413
#    default_lat = 19.415775291486027
#    default_zoom = 4
#    extra_js = ['http://openstreetmap.org/openlayers/OpenStreetMap.js', 'http://openlayers.org/dev/OpenLayers.js']

class DevelopmentAdmin(BaseGeoAdmin):
    search_fields = ['name', 'address']
    list_display = ('__unicode__', 'address', 'area', 'proposed_development_area', 'including_development_area',)      

class AreaAdmin(BaseGeoAdmin):
    search_fields = ['name', 'address']
    list_display = ('__unicode__', 'address', 'area',)    

class MillLandAdmin(BaseGeoAdmin):
    search_fields = ['name', 'address', 'old_name', 'owner']
    list_display = ('__unicode__', 'address', 'old_name', 'owner',)
    list_filter = ('owner',)  

class PedestrianAvenueAdmin(BaseGeoAdmin):
    search_fields = ['name']
    list_display = ('__unicode__', 'length',)
    

admin.site.register(OpenSpace, OpenSpaceAdmin)
admin.site.register(Forest, AreaAdmin)
admin.site.register(Fort, AreaAdmin)
admin.site.register(HillForest, AreaAdmin)
admin.site.register(Waterfront, AreaAdmin)
admin.site.register(River, DevelopmentAdmin)
admin.site.register(CreekWetland, DevelopmentAdmin)
admin.site.register(Nullah, DevelopmentAdmin)
admin.site.register(MillLand, MillLandAdmin)
admin.site.register(Beach, AreaAdmin)

